% 24 Bit Trailer CRC Algorithm for FlexRay Analysis Software
function CRC = Trailer_CRC(Message_Header,Message_Payload,Channel)
% Format data input
Message_Header = dec2bin(hex2dec(Message_Header),8);
Message_Payload = dec2bin(hex2dec(Message_Payload),8);
temp_header = '';
for i= 1:size(Message_Header,1)
    temp_header = strcat(temp_header,Message_Header(i,:));
end
temp_payload = '';
for i= 1:size(Message_Payload,1)
    temp_payload = strcat(temp_payload,Message_Payload(i,:));
end
% Initialise Variables
data_long = strcat(temp_header,temp_payload);
if strcmp('B',Channel)
    % Initialisation Vector Channel B
    CrcInit = int32(hex2dec('ABCDEF'));
else
    % Initialisation Vector Channel A
    CrcInit = int32(hex2dec('FEDCBA'));
end
CrcNext = int32(0);
CrcPoly = uint64(hex2dec('5D6DCB'));
CrcReg_X = uint64(CrcInit);
header_temp = uint64(0);
reg_temp = uint64(0);
CrcReg_X = bitshift(CrcReg_X,8);
CrcPoly = bitshift(CrcPoly,8);
data = uint32(bin2dec(data_long(1:31))); 
data_length = size(data_long,2);
bit_length = size(data_long,2);
i = 1;
% CRC Algorithm
while(data_length)
    data_length = data_length -1; 
    data = bitshift(data,1);
    if i <= bit_length-31
    data = bitor(data,bin2dec(data_long(i+31)));
    end
    i = i+1;
    header_temp = uint64(bitand(data,hex2dec('80000000')));
    reg_temp = bitand(CrcReg_X,hex2dec('80000000'));
    if (bitxor(header_temp,reg_temp))
        CrcNext = 1;
    else
        CrcNext = 0;
    end
    CrcReg_X = bitshift(CrcReg_X,1);
    if(CrcNext)
        CrcReg_X = bitxor(CrcReg_X,CrcPoly);
    end
end
% Format Output
CrcReg_X = bitshift(CrcReg_X,-8);
CrcReg_X = bitand(CrcReg_X,hex2dec('0000000000FFFFFF'));
CRC = dec2hex(CrcReg_X);
end
